//
// C++ Implementation: conditionmutex
//
// Description:
//
//
// Author: Gav Wood <gav@indigoarchive.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#define __SUCS 1

#include "conditionmutex.h"

namespace sucs
{

ConditionMutex::ConditionMutex() : Condition()
{
	theMutex = new Mutex;
}

ConditionMutex::~ConditionMutex()
{
	delete theMutex;
}

void ConditionMutex::signal(bool useMutex) const
{
	Condition::signal(useMutex);
}

void ConditionMutex::broadcast(bool useMutex) const
{
	Condition::broadcast(useMutex);
}

void ConditionMutex::lock() const
{
	theMutex->lock();
}

void ConditionMutex::unlock() const
{
	theMutex->unlock();
}

void ConditionMutex::wait(bool automatic) const
{
	if(automatic)
		lock();
	Condition::wait();
	if(automatic)
		unlock();
}
};
