/***************************************************************************
                          stub.cpp  -  Simple plugin example.
                             -------------------
    begin                : Tue Sep 18 2001
    copyright            : (C) 2001 by Gav Wood
    email                : gav@indigoarchive.net
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream>
using namespace std;

#include "factory.h"
using namespace sucs;

#include "filter.h"

int main(int argc, char **argv)
{
	if(argc < 2)
	{	cerr << "Usage: stub <filter plugin>" << endl;
		return 0;
	}

	Factory<Filter> myFactory(argv[1]);
	if(!myFactory.isOpen())
	{	cerr << "Couldn't open plugin " << argv[1] << "." << endl;
		return 0;
	}

	Filter *aSelfCat = myFactory.createInstance();
	cout << "Enter some text to filter through " << myFactory.getID() << ": " << flush;
	string in;
	cin >> in;
	cout << "Filtered text: " << aSelfCat->filter(in) << endl;
}
