/***************************************************************************
                          signalhandler.h  -  description
                             -------------------
    begin                : Thu Jan 13 2004
    copyright            : (C) 2004 by Gavin James Wood
    email                : gav@indigoarchive.net
 ***************************************************************************/

#ifndef _SUCS_SIGNALHANDLER_H
#define _SUCS_SIGNALHANDLER_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <vector>
#include <map>
using namespace std;

#include <signal.h>

namespace sucs
{

/**
@author Gav Wood
*/

//TODO: Make thread-safe!!!

class SignalListener;

class SignalHandler
{
	vector<int> theSignals;
	
	friend class SignalListener;
	void unregister(int signal);
	
public:
	virtual void handler(int signal) = 0;
	
	bool handle(int signal);
	bool unhandle(int signal);
	
	SignalHandler(int signal = 0);
	~SignalHandler();
};

};

#endif
