/***************************************************************************
                          stub.cpp  -  Simple XML reformatter.
                             -------------------
    begin                : Tue Sep 18 2001
    copyright            : (C) 2001 by Gav Wood
    email                : gav@indigoarchive.net
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream>
#include <string>
#include <map>

using namespace std;

#include "xmlreader.h"

using namespace sucs;

class MyReader: public XMLReader
{
protected:
	virtual void StartElement(const string &theName, const map<string, string> &theAttributes);
	virtual void EndElement(const string &theName);
	virtual void CharData(const string &theData);

public:
	int Depth;

	MyReader() : XMLReader(true) { Depth = 0; }
};

void MyReader::StartElement(const string &theName, const map<string, string> &theAttributes)
{
	for(int i = 0; i < Depth; i++)
		cout << "\t";
	cout << "<" << theName;

	for(map<string, string>::const_iterator j = theAttributes.begin(); j != theAttributes.end(); j++)
		cout << " " << j->first << "=\"" << j->second << "\"";
	cout << ">" << endl;

	Depth++;
}

void MyReader::CharData(const string &theData)
{
	for(int i = 0; i < Depth; i++)
		cout << "\t";
	cout << theData << endl;
}

void MyReader::EndElement(const string &theName)
{
	Depth--;

	for(int i = 0; i < Depth; i++)
		cout << "\t";
	cout << "</" << theName << ">" << endl;
}

int main()
{
	// Declare our new XML reader
	MyReader theReader;

	// Get some input from cin - as it is read, it will output it neatly
	cout << "Enter some XML with no spaces between elements followed by Ctrl-D: " << endl;
	cin >> theReader;
}
