/***************************************************************************
                          semaphore.cpp  -  description
                             -------------------
    begin                : Sun Jan 9 2000
    copyright            : (C) 2000 by Gavin James Wood
    email                : gav@indigoarchive.net
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#pragma implementation

#include <iostream>
#include <string>
#include <map>

using namespace std;

#include <expat.h>

#include "xmlreader.h"

using namespace sucs;

XMLReader::XMLReader(bool newStripWhite)
{
	StripWhite = newStripWhite;

	theParser = XML_ParserCreate(NULL);
	XML_SetUserData(theParser, this);
	XML_SetElementHandler(theParser, cStartElement, cEndElement);
	XML_SetCharacterDataHandler(theParser, cCharData);
}

XMLReader::~XMLReader()
{
	XML_ParserFree(theParser);
}

istream &sucs::operator>>(istream &in, XMLReader &me)
{
	char Buffer[256];
	while(!in.eof())
	{
		in.read(Buffer, 256);
		if(!XML_Parse(me.theParser, Buffer, in.gcount(), in.eof()))
		{
			cerr << "XMLReader: Line " << XML_GetCurrentLineNumber(me.theParser) << ": " << XML_ErrorString(XML_GetErrorCode(me.theParser)) << endl;
			return in;
		}
	}
	return in;
};

void sucs::cStartElement(void *userdata, const char *name, const char **atts)
{
	map<string, string> Attributes;

	for(int i = 0; atts[i]; i+=2)
		Attributes.insert(pair<string, string>(atts[i], atts[i + 1]));

	((XMLReader *)userdata)->StartElement(name, Attributes);
}

void sucs::cEndElement(void *userdata, const char *name)
{
	((XMLReader *)userdata)->EndElement(name);
}

void sucs::cCharData(void *userdata, const XML_Char *s, int len)
{
	char Buffer[len + 1];

	// shorten if neccessary
	int begin = 0, end = len - 1;
	if(((XMLReader *)userdata)->StripWhite)
	{
		for(; begin < len && s[begin] < 33; begin++);
		for(; end >= begin && s[end] < 33; end--);
	}

	// parse if there is something to parse
	if(end > begin)
	{
		memcpy(Buffer, s + begin, end - begin + 1);
		Buffer[end - begin + 1] = 0;
		((XMLReader *)userdata)->CharData(Buffer);
	}
}
